Index: include/ndk/pstypes.h
===================================================================
--- include/ndk/pstypes.h	(revision 21808)
+++ include/ndk/pstypes.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -76,6 +76,7 @@
 #define FLG_ENABLE_HANDLE_TYPE_TAGGING          0x01000000
 #define FLG_HEAP_PAGE_ALLOCS                    0x02000000
 #define FLG_DEBUG_INITIAL_COMMAND_EX            0x04000000
+#define FLG_VALID_BITS                          0x07FFFFFF
 
 //
 // Process priority classes
@@ -108,6 +109,11 @@
 #define PROCESS_PRIORITY_NORMAL_FOREGROUND      9
 
 //
+// Number of TLS expansion slots
+//
+#define TLS_EXPANSION_SLOTS                     64
+
+//
 // Process Access Types
 //
 #ifndef NTOS_MODE_USER
@@ -123,7 +129,15 @@
 #define PROCESS_QUERY_INFORMATION               0x0400
 #define PROCESS_SUSPEND_RESUME                  0x0800
 #define PROCESS_QUERY_LIMITED_INFORMATION       0x1000
-#define PROCESS_ALL_ACCESS                      (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 0xFFFF)
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+#define PROCESS_ALL_ACCESS                      (STANDARD_RIGHTS_REQUIRED | \
+                                                 SYNCHRONIZE | \
+                                                 0xFFFF)
+#else
+#define PROCESS_ALL_ACCESS                      (STANDARD_RIGHTS_REQUIRED | \
+                                                 SYNCHRONIZE | \
+                                                 0xFFF)
+#endif
 
 
 //
@@ -134,7 +148,9 @@
 #define JOB_OBJECT_QUERY                        0x4
 #define JOB_OBJECT_TERMINATE                    0x8
 #define JOB_OBJECT_SET_SECURITY_ATTRIBUTES      0x10
-#define JOB_OBJECT_ALL_ACCESS                   (STANDARD_RIGHTS_REQUIRED | SYNCHRONIZE | 31)
+#define JOB_OBJECT_ALL_ACCESS                   (STANDARD_RIGHTS_REQUIRED | \
+                                                 SYNCHRONIZE | \
+                                                 31)
 #endif
 
 #ifdef NTOS_MODE_USER
@@ -223,6 +239,8 @@
     ThreadCycleTime,
     ThreadPagePriority,
     ThreadActualBasePriority,
+    ThreadTebInformation,
+    ThreadCSwitchMon,
     MaxThreadInfoClass
 } THREADINFOCLASS;
 
@@ -244,30 +262,162 @@
 } JOBOBJECTINFOCLASS;
 
 //
+// Power Event Events for Win32K Power Event Callback
+//
+typedef enum _PSPOWEREVENTTYPE
+{
+    PsW32FullWake = 0,
+    PsW32EventCode = 1,
+    PsW32PowerPolicyChanged = 2,
+    PsW32SystemPowerState = 3,
+    PsW32SystemTime = 4,
+    PsW32DisplayState = 5,
+    PsW32CapabilitiesChanged = 6,
+    PsW32SetStateFailed = 7,
+    PsW32GdiOff = 8,
+    PsW32GdiOn = 9,
+    PsW32GdiPrepareResumeUI = 10,
+    PsW32GdiOffRequest = 11,
+    PsW32MonitorOff = 12,
+} PSPOWEREVENTTYPE;
+
+//
+// Power State Tasks for Win32K Power State Callback
+//
+typedef enum _POWERSTATETASK
+{
+    PowerState_BlockSessionSwitch = 0,
+    PowerState_Init = 1,
+    PowerState_QueryApps = 2,
+    PowerState_QueryServices = 3,
+    PowerState_QueryAppsFailed = 4,
+    PowerState_QueryServicesFailed = 5,
+    PowerState_SuspendApps = 6,
+    PowerState_SuspendServices = 7,
+    PowerState_ShowUI = 8,
+    PowerState_NotifyWL = 9,
+    PowerState_ResumeApps = 10,
+    PowerState_ResumeServices = 11,
+    PowerState_UnBlockSessionSwitch = 12,
+    PowerState_End = 13,
+    PowerState_BlockInput = 14,
+    PowerState_UnblockInput = 15,
+} POWERSTATETASK;
+
+//
+// Win32K Job Callback Types
+//
+typedef enum _PSW32JOBCALLOUTTYPE
+{
+   PsW32JobCalloutSetInformation = 0,
+   PsW32JobCalloutAddProcess = 1,
+   PsW32JobCalloutTerminate = 2,
+} PSW32JOBCALLOUTTYPE;
+
+//
+// Win32K Thread Callback Types
+//
+typedef enum _PSW32THREADCALLOUTTYPE
+{
+    PsW32ThreadCalloutInitialize,
+    PsW32ThreadCalloutExit,
+} PSW32THREADCALLOUTTYPE;
+
+//
 // Declare empty structure definitions so that they may be referenced by
 // routines before they are defined
 //
 struct _W32THREAD;
 struct _W32PROCESS;
 struct _ETHREAD;
+struct _WIN32_POWEREVENT_PARAMETERS;
+struct _WIN32_POWERSTATE_PARAMETERS;
+struct _WIN32_JOBCALLOUT_PARAMETERS;
+struct _WIN32_OPENMETHOD_PARAMETERS;
+struct _WIN32_OKTOCLOSEMETHOD_PARAMETERS;
+struct _WIN32_CLOSEMETHOD_PARAMETERS;
+struct _WIN32_DELETEMETHOD_PARAMETERS;
+struct _WIN32_PARSEMETHOD_PARAMETERS;
 
 //
 // Win32K Process and Thread Callbacks
 //
 typedef NTSTATUS
-(NTAPI *PW32_PROCESS_CALLBACK)(
+(NTAPI *PKWIN32_PROCESS_CALLOUT)(
     struct _EPROCESS *Process,
     BOOLEAN Create
 );
 
 typedef NTSTATUS
-(NTAPI *PW32_THREAD_CALLBACK)(
+(NTAPI *PKWIN32_THREAD_CALLOUT)(
     struct _ETHREAD *Thread,
-    BOOLEAN Create
+    PSW32THREADCALLOUTTYPE Type
 );
 
+typedef NTSTATUS
+(NTAPI *PKWIN32_GLOBALATOMTABLE_CALLOUT)(
+    VOID
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_POWEREVENT_CALLOUT)(
+    struct _WIN32_POWEREVENT_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_POWERSTATE_CALLOUT)(
+    struct _WIN32_POWERSTATE_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_JOB_CALLOUT)(
+    struct _WIN32_JOBCALLOUT_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PGDI_BATCHFLUSH_ROUTINE)(
+    VOID
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_OPENMETHOD_CALLOUT)(
+    struct _WIN32_OPENMETHOD_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_OKTOCLOSEMETHOD_CALLOUT)(
+    struct _WIN32_OKTOCLOSEMETHOD_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_CLOSEMETHOD_CALLOUT)(
+    struct _WIN32_CLOSEMETHOD_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_DELETEMETHOD_CALLOUT)(
+    struct _WIN32_DELETEMETHOD_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_PARSEMETHOD_CALLOUT)(
+    struct _WIN32_PARSEMETHOD_PARAMETERS *Parameters
+);
+
+typedef NTSTATUS
+(NTAPI *PKWIN32_WIN32DATACOLLECTION_CALLOUT)(
+    struct _EPROCESS *Process,
+    PVOID Callback,
+    PVOID Context
+);
+
 #endif
 
+typedef NTSTATUS
+(NTAPI *PPOST_PROCESS_INIT_ROUTINE)(
+    VOID
+);
+
 #ifdef NTOS_MODE_USER
 
 //
@@ -313,63 +463,112 @@
 //
 typedef struct _PEB
 {
-    UCHAR InheritedAddressSpace;                     /* 00h */
-    UCHAR ReadImageFileExecOptions;                  /* 01h */
-    UCHAR BeingDebugged;                             /* 02h */
-    BOOLEAN SpareBool;                               /* 03h */
-    HANDLE Mutant;                                   /* 04h */
-    PVOID ImageBaseAddress;                          /* 08h */
-    PPEB_LDR_DATA Ldr;                               /* 0Ch */
-    struct _RTL_USER_PROCESS_PARAMETERS *ProcessParameters;  /* 10h */
-    PVOID SubSystemData;                             /* 14h */
-    PVOID ProcessHeap;                               /* 18h */
-    PVOID FastPebLock;                               /* 1Ch */
-    PPEBLOCKROUTINE FastPebLockRoutine;              /* 20h */
-    PPEBLOCKROUTINE FastPebUnlockRoutine;            /* 24h */
-    ULONG EnvironmentUpdateCount;                    /* 28h */
-    PVOID* KernelCallbackTable;                      /* 2Ch */
-    PVOID EventLogSection;                           /* 30h */
-    PVOID EventLog;                                  /* 34h */
-    PPEB_FREE_BLOCK FreeList;                        /* 38h */
-    ULONG TlsExpansionCounter;                       /* 3Ch */
-    PVOID TlsBitmap;                                 /* 40h */
-    ULONG TlsBitmapBits[0x2];                        /* 44h */
-    PVOID ReadOnlySharedMemoryBase;                  /* 4Ch */
-    PVOID ReadOnlySharedMemoryHeap;                  /* 50h */
-    PVOID* ReadOnlyStaticServerData;                 /* 54h */
-    PVOID AnsiCodePageData;                          /* 58h */
-    PVOID OemCodePageData;                           /* 5Ch */
-    PVOID UnicodeCaseTableData;                      /* 60h */
-    ULONG NumberOfProcessors;                        /* 64h */
-    ULONG NtGlobalFlag;                              /* 68h */
-    LARGE_INTEGER CriticalSectionTimeout;            /* 70h */
-    ULONG HeapSegmentReserve;                        /* 78h */
-    ULONG HeapSegmentCommit;                         /* 7Ch */
-    ULONG HeapDeCommitTotalFreeThreshold;            /* 80h */
-    ULONG HeapDeCommitFreeBlockThreshold;            /* 84h */
-    ULONG NumberOfHeaps;                             /* 88h */
-    ULONG MaximumNumberOfHeaps;                      /* 8Ch */
-    PVOID* ProcessHeaps;                             /* 90h */
-    PVOID GdiSharedHandleTable;                      /* 94h */
-    PVOID ProcessStarterHelper;                      /* 98h */
-    PVOID GdiDCAttributeList;                        /* 9Ch */
-    PVOID LoaderLock;                                /* A0h */
-    ULONG OSMajorVersion;                            /* A4h */
-    ULONG OSMinorVersion;                            /* A8h */
-    USHORT OSBuildNumber;                            /* ACh */
-    USHORT OSCSDVersion;                             /* AEh */
-    ULONG OSPlatformId;                              /* B0h */
-    ULONG ImageSubSystem;                            /* B4h */
-    ULONG ImageSubSystemMajorVersion;                /* B8h */
-    ULONG ImageSubSystemMinorVersion;                /* BCh */
-    ULONG ImageProcessAffinityMask;                  /* C0h */
-    ULONG GdiHandleBuffer[0x22];                     /* C4h */
-    PVOID PostProcessInitRoutine;                    /* 14Ch */
-    struct _RTL_BITMAP *TlsExpansionBitmap;          /* 150h */
-    ULONG TlsExpansionBitmapBits[0x20];              /* 154h */
-    ULONG SessionId;                                 /* 1D4h */
-    PVOID AppCompatInfo;                             /* 1D8h */
-    UNICODE_STRING CSDVersion;                       /* 1DCh */
+    UCHAR InheritedAddressSpace;
+    UCHAR ReadImageFileExecOptions;
+    UCHAR BeingDebugged;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    struct
+    {
+        UCHAR ImageUsesLargePages:1;
+        UCHAR IsProtectedProcess:1;
+        UCHAR IsLegacyProcess:1;
+        UCHAR SpareBits:5;
+    };
+#else
+    BOOLEAN SpareBool;
+#endif
+    HANDLE Mutant;
+    PVOID ImageBaseAddress;
+    PPEB_LDR_DATA Ldr;
+    struct _RTL_USER_PROCESS_PARAMETERS *ProcessParameters;
+    PVOID SubSystemData;
+    PVOID ProcessHeap;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    struct _RTL_CRITICAL_SECTION *FastPebLock;
+    PVOID AltThunkSListPtr;
+    PVOID IFEOKey;
+    ULONG Spare;
+    union
+    {
+        PVOID* KernelCallbackTable;
+        PVOID UserSharedInfoPtr;
+    };
+    ULONG SystemReserved[1];
+    ULONG SpareUlong;
+#else
+    PVOID FastPebLock;
+    PPEBLOCKROUTINE FastPebLockRoutine;
+    PPEBLOCKROUTINE FastPebUnlockRoutine;
+    ULONG EnvironmentUpdateCount;
+    PVOID* KernelCallbackTable;
+    PVOID EventLogSection;
+    PVOID EventLog;
+#endif
+    PPEB_FREE_BLOCK FreeList;
+    ULONG TlsExpansionCounter;
+    PVOID TlsBitmap;
+    ULONG TlsBitmapBits[0x2];
+    PVOID ReadOnlySharedMemoryBase;
+    PVOID ReadOnlySharedMemoryHeap;
+    PVOID* ReadOnlyStaticServerData;
+    PVOID AnsiCodePageData;
+    PVOID OemCodePageData;
+    PVOID UnicodeCaseTableData;
+    ULONG NumberOfProcessors;
+    ULONG NtGlobalFlag;
+    LARGE_INTEGER CriticalSectionTimeout;
+    ULONG HeapSegmentReserve;
+    ULONG HeapSegmentCommit;
+    ULONG HeapDeCommitTotalFreeThreshold;
+    ULONG HeapDeCommitFreeBlockThreshold;
+    ULONG NumberOfHeaps;
+    ULONG MaximumNumberOfHeaps;
+    PVOID* ProcessHeaps;
+    PVOID GdiSharedHandleTable;
+    PVOID ProcessStarterHelper;
+    PVOID GdiDCAttributeList;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    struct _RTL_CRITICAL_SECTION *LoaderLock;
+#else
+    PVOID LoaderLock;
+#endif
+    ULONG OSMajorVersion;
+    ULONG OSMinorVersion;
+    USHORT OSBuildNumber;
+    USHORT OSCSDVersion;
+    ULONG OSPlatformId;
+    ULONG ImageSubSystem;
+    ULONG ImageSubSystemMajorVersion;
+    ULONG ImageSubSystemMinorVersion;
+    ULONG ImageProcessAffinityMask;
+    ULONG GdiHandleBuffer[0x22];
+    PPOST_PROCESS_INIT_ROUTINE PostProcessInitRoutine;
+    struct _RTL_BITMAP *TlsExpansionBitmap;
+    ULONG TlsExpansionBitmapBits[0x20];
+    ULONG SessionId;
+#if (NTDDI_VERSION >= NTDDI_WINXP)
+    ULARGE_INTEGER AppCompatFlags;
+    ULARGE_INTEGER AppCompatFlagsUser;
+    PVOID pShimData;
+    PVOID AppCompatInfo;
+    UNICODE_STRING CSDVersion;
+    struct _ACTIVATION_CONTEXT_DATA *ActivationContextData;
+    struct _ASSEMBLY_STORAGE_MAP *ProcessAssemblyStorageMap;
+    struct _ACTIVATION_CONTEXT_DATA *SystemDefaultActivationContextData;
+    struct _ASSEMBLY_STORAGE_MAP *SystemAssemblyStorageMap;
+    ULONG MinimumStackCommit;
+#endif
+#if (NTDDI_VERSION >= NTDDI_WS03)
+    PVOID *FlsCallback;
+    LIST_ENTRY FlsListHead;
+    struct _RTL_BITMAP *FlsBitmap;
+    ULONG FlsBitmapBits[4];
+    ULONG FlsHighIndex;
+#endif
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    PVOID WerRegistrationData;
+    PVOID WerShipAssertPtr;
+#endif
 } PEB, *PPEB;
 
 //
@@ -415,77 +614,129 @@
 //
 typedef struct _TEB
 {
-    NT_TIB Tib;                             /* 00h */
-    PVOID EnvironmentPointer;               /* 1Ch */
-    CLIENT_ID Cid;                          /* 20h */
-    PVOID ActiveRpcHandle;                  /* 28h */
-    PVOID ThreadLocalStoragePointer;        /* 2Ch */
-    struct _PEB *ProcessEnvironmentBlock;   /* 30h */
-    ULONG LastErrorValue;                   /* 34h */
-    ULONG CountOfOwnedCriticalSections;     /* 38h */
-    PVOID CsrClientThread;                  /* 3Ch */
-    PVOID Win32ThreadInfo;                  /* 40h */
-    ULONG User32Reserved[0x1A];             /* 44h */
-    ULONG UserReserved[5];                  /* ACh */
-    PVOID WOW32Reserved;                    /* C0h */
-    LCID CurrentLocale;                     /* C4h */
-    ULONG FpSoftwareStatusRegister;         /* C8h */
-    PVOID SystemReserved1[0x36];            /* CCh */
-    LONG ExceptionCode;                     /* 1A4h */
-    struct _ACTIVATION_CONTEXT_STACK *ActivationContextStackPointer; /* 1A8h */
-    UCHAR SpareBytes1[0x28];                /* 1ACh */
-    GDI_TEB_BATCH GdiTebBatch;              /* 1D4h */
-    CLIENT_ID RealClientId;                 /* 6B4h */
-    PVOID GdiCachedProcessHandle;           /* 6BCh */
-    ULONG GdiClientPID;                     /* 6C0h */
-    ULONG GdiClientTID;                     /* 6C4h */
-    PVOID GdiThreadLocalInfo;               /* 6C8h */
-    ULONG Win32ClientInfo[62];              /* 6CCh */
-    PVOID glDispatchTable[0xE9];            /* 7C4h */
-    ULONG glReserved1[0x1D];                /* B68h */
-    PVOID glReserved2;                      /* BDCh */
-    PVOID glSectionInfo;                    /* BE0h */
-    PVOID glSection;                        /* BE4h */
-    PVOID glTable;                          /* BE8h */
-    PVOID glCurrentRC;                      /* BECh */
-    PVOID glContext;                        /* BF0h */
-    NTSTATUS LastStatusValue;               /* BF4h */
-    UNICODE_STRING StaticUnicodeString;     /* BF8h */
-    WCHAR StaticUnicodeBuffer[0x105];       /* C00h */
-    PVOID DeallocationStack;                /* E0Ch */
-    PVOID TlsSlots[0x40];                   /* E10h */
-    LIST_ENTRY TlsLinks;                    /* F10h */
-    PVOID Vdm;                              /* F18h */
-    PVOID ReservedForNtRpc;                 /* F1Ch */
-    PVOID DbgSsReserved[0x2];               /* F20h */
-    ULONG HardErrorDisabled;                /* F28h */
-    PVOID Instrumentation[14];              /* F2Ch */
-    PVOID SubProcessTag;                    /* F64h */
-    PVOID EtwTraceData;                     /* F68h */
-    PVOID WinSockData;                      /* F6Ch */
-    ULONG GdiBatchCount;                    /* F70h */
-    BOOLEAN InDbgPrint;                     /* F74h */
-    BOOLEAN FreeStackOnTermination;         /* F75h */
-    BOOLEAN HasFiberData;                   /* F76h */
-    UCHAR IdealProcessor;                   /* F77h */
-    ULONG GuaranteedStackBytes;             /* F78h */
-    PVOID ReservedForPerf;                  /* F7Ch */
-    PVOID ReservedForOle;                   /* F80h */
-    ULONG WaitingOnLoaderLock;              /* F84h */
-    ULONG SparePointer1;                    /* F88h */
-    ULONG SoftPatchPtr1;                    /* F8Ch */
-    ULONG SoftPatchPtr2;                    /* F90h */
-    PVOID *TlsExpansionSlots;               /* F94h */
-    ULONG ImpersionationLocale;             /* F98h */
-    ULONG IsImpersonating;                  /* F9Ch */
-    PVOID NlsCache;                         /* FA0h */
-    PVOID pShimData;                        /* FA4h */
-    ULONG HeapVirualAffinity;               /* FA8h */
-    PVOID CurrentTransactionHandle;         /* FACh */
-    PTEB_ACTIVE_FRAME ActiveFrame;          /* FB0h */
-    PVOID FlsData;                          /* FB4h */
-    UCHAR SafeThunkCall;                    /* FB8h */
-    UCHAR BooleanSpare[3];                  /* FB9h */
+    NT_TIB Tib;
+    PVOID EnvironmentPointer;
+    CLIENT_ID Cid;
+    PVOID ActiveRpcHandle;
+    PVOID ThreadLocalStoragePointer;
+    struct _PEB *ProcessEnvironmentBlock;
+    ULONG LastErrorValue;
+    ULONG CountOfOwnedCriticalSections;
+    PVOID CsrClientThread;
+    struct _W32THREAD* Win32ThreadInfo;
+    ULONG User32Reserved[0x1A];
+    ULONG UserReserved[5];
+    PVOID WOW32Reserved;
+    LCID CurrentLocale;
+    ULONG FpSoftwareStatusRegister;
+    PVOID SystemReserved1[0x36];
+    LONG ExceptionCode;
+    struct _ACTIVATION_CONTEXT_STACK *ActivationContextStackPointer;
+    UCHAR SpareBytes1[0x24];
+    ULONG TxFsContext;
+    GDI_TEB_BATCH GdiTebBatch;
+    CLIENT_ID RealClientId;
+    PVOID GdiCachedProcessHandle;
+    ULONG GdiClientPID;
+    ULONG GdiClientTID;
+    PVOID GdiThreadLocalInfo;
+    ULONG Win32ClientInfo[62];
+    PVOID glDispatchTable[0xE9];
+    ULONG glReserved1[0x1D];
+    PVOID glReserved2;
+    PVOID glSectionInfo;
+    PVOID glSection;
+    PVOID glTable;
+    PVOID glCurrentRC;
+    PVOID glContext;
+    NTSTATUS LastStatusValue;
+    UNICODE_STRING StaticUnicodeString;
+    WCHAR StaticUnicodeBuffer[0x105];
+    PVOID DeallocationStack;
+    PVOID TlsSlots[0x40];
+    LIST_ENTRY TlsLinks;
+    PVOID Vdm;
+    PVOID ReservedForNtRpc;
+    PVOID DbgSsReserved[0x2];
+    ULONG HardErrorDisabled;
+    PVOID Instrumentation[9];
+    GUID ActivityId;
+    PVOID SubProcessTag;
+    PVOID EtwTraceData;
+    PVOID WinSockData;
+    ULONG GdiBatchCount;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    BOOLEAN SpareBool0;
+    BOOLEAN SpareBool1;
+    BOOLEAN SpareBool2;
+#else
+    BOOLEAN InDbgPrint;
+    BOOLEAN FreeStackOnTermination;
+    BOOLEAN HasFiberData;
+#endif
+    UCHAR IdealProcessor;
+    ULONG GuaranteedStackBytes;
+    PVOID ReservedForPerf;
+    PVOID ReservedForOle;
+    ULONG WaitingOnLoaderLock;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    PVOID SavedPriorityState;
+#else
+    ULONG SparePointer1;
+#endif
+    ULONG SoftPatchPtr1;
+    ULONG SoftPatchPtr2;
+    PVOID *TlsExpansionSlots;
+    ULONG ImpersionationLocale;
+    ULONG IsImpersonating;
+    PVOID NlsCache;
+    PVOID pShimData;
+    ULONG HeapVirualAffinity;
+    PVOID CurrentTransactionHandle;
+    PTEB_ACTIVE_FRAME ActiveFrame;
+#if (NTDDI_VERSION >= NTDDI_WS03)
+    PVOID FlsData;
+#endif
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    PVOID PreferredLangauges;
+    PVOID UserPrefLanguages;
+    PVOID MergedPrefLanguages;
+    ULONG MuiImpersonation;
+    union
+    {
+        struct
+        {
+            USHORT SpareCrossTebFlags:16;
+        };
+        USHORT CrossTebFlags;
+    };
+    union
+    {
+        struct
+        {
+            USHORT DbgSafeThunkCall:1;
+            USHORT DbgInDebugPrint:1;
+            USHORT DbgHasFiberData:1;
+            USHORT DbgSkipThreadAttach:1;
+            USHORT DbgWerInShipAssertCode:1;
+            USHORT DbgIssuedInitialBp:1;
+            USHORT DbgClonedThread:1;
+            USHORT SpareSameTebBits:9;
+        };
+        USHORT SameTebFlags;
+    };
+    PVOID TxnScopeEntercallback;
+    PVOID TxnScopeExitCAllback;
+    PVOID TxnScopeContext;
+    ULONG LockCount;
+    ULONG ProcessRundown;
+    ULONGLONG LastSwitchTime;
+    ULONGLONG TotalSwitchOutTime;
+    LARGE_INTEGER WaitReasonBitMap;
+#else
+    UCHAR SafeThunkCall;
+    UCHAR BooleanSpare[3];
+#endif
 } TEB, *PTEB;
 
 #ifdef NTOS_MODE_USER
@@ -543,7 +794,7 @@
 typedef struct _PROCESS_PRIORITY_CLASS
 {
     BOOLEAN Foreground;
-    UCHAR   PriorityClass;
+    UCHAR PriorityClass;
 } PROCESS_PRIORITY_CLASS, *PPROCESS_PRIORITY_CLASS;
 
 //
@@ -581,7 +832,7 @@
 } EPROCESS_QUOTA_BLOCK, *PEPROCESS_QUOTA_BLOCK;
 
 //
-// FIXME: This really belongs in mmtypes.h
+// Process Pagefault History
 //
 typedef struct _PAGEFAULT_HISTORY
 {
